/**
 * @license
 * Fuse - Lightweight fuzzy-search
 *
 * Copyright (c) 2012-2016 Kirollos Risk <kirollos@gmail.com>.
 * All Rights Reserved. Apache Software License 2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License")
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
!function(t){"use strict";function e(){console.log.apply(null,arguments)}function s(t,e){var s,r,n,i;for(this.list=t,this.options=e=e||{},s=0,i=["sort","shouldSort","verbose"],r=i.length;r>s;s++)n=i[s],this.options[n]=n in e?e[n]:h[n];for(s=0,i=["searchFn","sortFn","keys","getFn","include"],r=i.length;r>s;s++)n=i[s],this.options[n]=e[n]||h[n]}function r(t,e,s){var i,o,h,a,p,c;if(e){if(h=e.indexOf("."),-1!==h?(i=e.slice(0,h),o=e.slice(h+1)):i=e,a=t[i],null!==a&&void 0!==a)if(o||"string"!=typeof a&&"number"!=typeof a)if(n(a))for(p=0,c=a.length;c>p;p++)r(a[p],o,s);else o&&r(a,o,s);else s.push(a)}else s.push(t);return s}function n(t){return"[object Array]"===Object.prototype.toString.call(t)}function i(t,e){e=e||{},this.options=e,this.options.location=e.location||i.defaultOptions.location,this.options.distance="distance"in e?e.distance:i.defaultOptions.distance,this.options.threshold="threshold"in e?e.threshold:i.defaultOptions.threshold,this.options.maxPatternLength=e.maxPatternLength||i.defaultOptions.maxPatternLength,this.pattern=e.caseSensitive?t:t.toLowerCase(),this.patternLen=t.length,this.patternLen<=this.options.maxPatternLength&&(this.matchmask=1<<this.patternLen-1,this.patternAlphabet=this._calculatePatternAlphabet())}var o=/ +/g,h={id:null,caseSensitive:!1,include:[],shouldSort:!0,searchFn:i,sortFn:function(t,e){return t.score-e.score},getFn:r,keys:[],verbose:!1};s.VERSION="2.0.0",s.prototype.set=function(t){return this.list=t,t},s.prototype.search=function(t){this.options.verbose&&e("=====================\n","Search term:",t),this.pattern=t,this.results=[],this.resultMap={},this._prepareSearchers(),this._startSearch(),this._computeScore(),this._sort();var s=this._format();return s},s.prototype._prepareSearchers=function(){var t=this.options,e=this.pattern,s=t.searchFn,r=e.split(o),n=0,i=r.length;for(this.tokenSearchers=[];i>n;n++)this.tokenSearchers.push(new s(r[n],t));this.fullSeacher=new s(e,t)},s.prototype._startSearch=function(){var t,e,s=this.options,r=s.getFn,n=this.list,i=n.length,o=this.options.keys,h=o.length,a=null;if("string"==typeof n[0])for(t=0;i>t;t++)this._analyze(n[t],t,t);else for(t=0;i>t;t++)for(a=n[t],e=0;h>e;e++)this._analyze(r(a,o[e],[]),a,t)},s.prototype._analyze=function(t,s,r){{var i,h,a,p,c,l,u,f,d,g,v,m,S,y=this.options,b=!1,_=this.tokenSearchers;_.length}if(void 0!==t&&null!==t)if(h=[],"string"==typeof t){for(i=t.split(o),y.verbose&&e("---------\n","Record:",i),m=0;m<this.tokenSearchers.length;m++){for(f=this.tokenSearchers[m],d=[],S=0;S<i.length;S++)g=i[S],v=f.search(g),v.isMatch?(b=!0,d.push(v.score),h.push(v.score)):(d.push(1),h.push(1));y.verbose&&e('Score for "'+f.pattern+'":',d)}for(p=h[0],l=h.length,m=1;l>m;m++)p+=h[m];p/=l,y.verbose&&e("Individual word score average:",p),u=this.fullSeacher.search(t),y.verbose&&e("Full text score:",u.score),c=u.score,void 0!==p&&(c=(c+p)/2),y.verbose&&e("Average",c),(b||u.isMatch)&&(a=this.resultMap[r],a?a.scores.push(c):(this.resultMap[r]={item:s,scores:[c]},this.results.push(this.resultMap[r])))}else if(n(t))for(m=0;m<t.length;m++)this._analyze(t[m],s,r)},s.prototype._computeScore=function(){var t,e,s,r,n,i=this.results;for(t=0;t<i.length;t++){for(s=0,r=i[t].scores,n=r.length,e=0;n>e;e++)s+=r[e];i[t].score=s/n}},s.prototype._sort=function(){var t=this.options;t.shouldSort&&(t.verbose&&e("Sorting...."),this.results.sort(t.sortFn))},s.prototype._format=function(){var t,s,r,n,i,o=this.options,h=o.getFn,a=[],p=this.results;for(o.verbose&&e("------------\n","Output:\n",p),n=o.id?function(t){p[t].item=h(p[t].item,o.id,[])[0]}:function(){},i=function(t){var e,s,r;if(o.include.length>0)for(e={item:p[t].item},r=0;r<o.include.length;r++)s=o.include[r],e[s]=p[t][s];else e=p[t].item;return e},s=0,r=p.length;r>s;s++)n(s),t=i(s),a.push(t);return a},i.defaultOptions={location:0,distance:100,threshold:.6,maxPatternLength:32},i.prototype._calculatePatternAlphabet=function(){var t={},e=0;for(e=0;e<this.patternLen;e++)t[this.pattern.charAt(e)]=0;for(e=0;e<this.patternLen;e++)t[this.pattern.charAt(e)]|=1<<this.pattern.length-e-1;return t},i.prototype._bitapScore=function(t,e){var s=t/this.patternLen,r=Math.abs(this.options.location-e);return this.options.distance?s+r/this.options.distance:r?1:s},i.prototype.search=function(t){var e,s,r,n,i,h,a,p,c,l,u,f,d,g,v,m,S,y,b=this.options;if(t=b.caseSensitive?t:t.toLowerCase(),this.pattern===t)return{isMatch:!0,score:0};if(this.patternLen>b.maxPatternLength)return S=t.match(new RegExp(this.pattern.replace(o,"|"))),y=!!S,{isMatch:y,score:y?.5:1};for(n=b.location,r=t.length,i=b.threshold,h=t.indexOf(this.pattern,n),-1!=h&&(i=Math.min(this._bitapScore(0,h),i),h=t.lastIndexOf(this.pattern,n+this.patternLen),-1!=h&&(i=Math.min(this._bitapScore(0,h),i))),h=-1,v=1,m=[],c=this.patternLen+r,e=0;e<this.patternLen;e++){for(a=0,p=c;p>a;)this._bitapScore(e,n+p)<=i?a=p:c=p,p=Math.floor((c-a)/2+a);for(c=p,l=Math.max(1,n-p+1),u=Math.min(n+p,r)+this.patternLen,f=Array(u+2),f[u+1]=(1<<e)-1,s=u;s>=l;s--)if(g=this.patternAlphabet[t.charAt(s-1)],f[s]=0===e?(f[s+1]<<1|1)&g:(f[s+1]<<1|1)&g|((d[s+1]|d[s])<<1|1)|d[s+1],f[s]&this.matchmask&&(v=this._bitapScore(e,s-1)||.001,i>=v)){if(i=v,h=s-1,m.push(h),!(h>n))break;l=Math.max(1,2*n-h)}if(this._bitapScore(e+1,n)>i)break;d=f}return{isMatch:h>=0,score:v}},"object"==typeof exports?module.exports=s:"function"==typeof define&&define.amd?define(function(){return s}):t.Fuse=s}(this);